*
* C-FLEA Debug Kernal for use with EMILY-CF
*
* This program must be assembled (asmcf emdebug -t), then the resulting
* .HEX file (emdebug.hex) loaded into the target C-FLEA system prior to
* running EMILY-CF (emcf) with Hardware Interfacing enabled (/H option).
*
* Copyright 1994-2005 Dave Dunfield
* All rights reserved.
*
IOWRITE	EQU	%10000000	Indicates write operation
* For really FAST cflea, increase IOTIMER, for slower, decrease
IOTIMER	EQU	10000		Loops to read timeout
*
	ORG	$1000		Place code here
*
* Main loop
*
top	IN	0		Get command character
	INC			Test for character
	SJZ	top		None ready
	DEC			Restore character
	PUSHA			Save for later
	ANDB	#IOWRITE	Write command?
	SJNZ	write		Do the write
*
* Read a value from an I/O port
*
	LD	S+		Get port ID back
	LEAI	rtable		Point to read handler table
	SWITCH			Execute handler
*
* Write byte to an I/O port
*
write	LDI	#IOTIMER	Read timeout count
wri1	IN	0		Read byte to write
	INC			Test for character
	SJNZ	wri2		Got one, go for it
	TIA			Get index
	DEC			Reduce
	TAI			Resave
	SJNZ	wri1		And try again
	SJMP	top		Timeout, Ignore
wri2	DEC			Restore character
	PUSHA			Save for later
	LD	2,S		Get port ID back
	ANDB	#~IOWRITE	Clear write bit
	LEAI	wtable		Point to write handler table
	SWITCH			Execute handler
*
* READ handler table, Add more entries as necessary
*
rtable	FDB	in01,$01	Port 01 input handler
	FDB	in02,$02	Port 02 input handler
	FDB	in03,$03	Port 03 input handler
	FDB	in04,$04	Port 04 input handler
	FDB	in05,$05	Port 05 input handler
	FDB	in06,$06	Port 06 input handler
	FDB	in07,$07	Port 07 input handler
	FDB	in08,$08	Port 08 input handler
	FDB	in09,$09	Port 09 input handler
	FDB	in81,$81	Port 81 input handler
	FDB	in82,$82	Port 82 input handler
	FDB	in83,$83	Port 83 input handler
	FDB	in84,$84	Port 84 input handler
	FDB	in85,$85	Port 85 input handler
	FDB	in86,$86	Port 86 input handler
	FDB	in87,$87	Port 87 input handler
	FDB	in88,$88	Port 88 input handler
	FDB	in89,$89	Port 89 input handler
	FDB	0,bport		Invalid PORT id
* Send value to PC and return to to top of loop
bport	CLR			Get a zero
txbyte	OUT	0		Write byte to PC
	SJMP	top		And re-execute loop
* READ handler code, add more routines as necessary
in01	IN	$01		Read port 01
	SJMP	txbyte		Transmit to PC
in02	IN	$02		Read port 02
	SJMP	txbyte		Transmit to PC
in03	IN	$03		Read port 03
	SJMP	txbyte		Transmit to PC
in04	IN	$04		Read port 04
	SJMP	txbyte		Transmit to PC
in05	IN	$05		Read port 05
	SJMP	txbyte		Transmit to PC
in06	IN	$06		Read port 06
	SJMP	txbyte		Transmit to PC
in07	IN	$07		Read port 07
	SJMP	txbyte		Transmit to PC
in08	IN	$08		Read port 08
	SJMP	txbyte		Transmit to PC
in09	IN	$09		Read port 09
	SJMP	txbyte		Transmit to PC
in81	IN	$81		Read port 81
	SJMP	txbyte		Transmit to PC
in82	IN	$82		Read port 82
	SJMP	txbyte		Transmit to PC
in83	IN	$83		Read port 83
	SJMP	txbyte		Transmit to PC
in84	IN	$84		Read port 84
	SJMP	txbyte		Transmit to PC
in85	IN	$85		Read port 85
	SJMP	txbyte		Transmit to PC
in86	IN	$86		Read port 86
	SJMP	txbyte		Transmit to PC
in87	IN	$87		Read port 87
	SJMP	txbyte		Transmit to PC
in88	IN	$88		Read port 88
	SJMP	txbyte		Transmit to PC
in89	IN	$89		Read port 89
	SJMP	txbyte		Transmit to PC
*
* WRITE handler table, add more entries as necessary
*
wtable	FDB	out01,1		Port 1 output handler
	FDB	out02,2		Port 2 output handler
	FDB	out03,3		Port 3 output handler
	FDB	out04,4		Port 4 output handler
	FDB	out05,5		Port 5 output handler
	FDB	out06,6		Port 6 output handler
	FDB	out07,7		Port 7 output handler
	FDB	out08,8		Port 8 output handler
	FDB	out09,9		Port 9 output handler
	FDB	out81,1		Port 1 output handler
	FDB	out82,2		Port 2 output handler
	FDB	out83,3		Port 3 output handler
	FDB	out84,4		Port 4 output handler
	FDB	out85,5		Port 5 output handler
	FDB	out86,6		Port 6 output handler
	FDB	out87,7		Port 7 output handler
	FDB	out88,8		Port 8 output handler
	FDB	out89,9		Port 9 output handler
	FDB	0,wend2		Ignore bad output
* WRITE handler code, add more routines as necessary
out01	LD	S+		Get value
	OUT	$01		Write to port 01
	SJMP	wend1		And proceed
out02	LD	S+		Get value
	OUT	$02		Write to port 02
	SJMP	wend1		And proceed
out03	LD	S+		Get value
	OUT	$03		Write to port 03
	SJMP	wend1		And proceed
out04	LD	S+		Get value
	OUT	$04		Write to port 04
	SJMP	wend1		And proceed
out05	LD	S+		Get value
	OUT	$05		Write to port 05
	SJMP	wend1		And proceed
out06	LD	S+		Get value
	OUT	$06		Write to port 06
	SJMP	wend1		And proceed
out07	LD	S+		Get value
	OUT	$07		Write to port 07
	SJMP	wend1		And proceed
out08	LD	S+		Get value
	OUT	$08		Write to port 08
	SJMP	wend1		And proceed
out09	LD	S+		Get value
	OUT	$09		Write to port 09
	SJMP	wend1		And proceed
out81	LD	S+		Get value
	OUT	$81		Write to port 81
	SJMP	wend1		And proceed
out82	LD	S+		Get value
	OUT	$82		Write to port 82
	SJMP	wend1		And proceed
out83	LD	S+		Get value
	OUT	$83		Write to port 83
	SJMP	wend1		And proceed
out84	LD	S+		Get value
	OUT	$84		Write to port 84
	SJMP	wend1		And proceed
out85	LD	S+		Get value
	OUT	$85		Write to port 85
	SJMP	wend1		And proceed
out86	LD	S+		Get value
	OUT	$86		Write to port 86
	SJMP	wend1		And proceed
out87	LD	S+		Get value
	OUT	$87		Write to port 87
	SJMP	wend1		And proceed
out88	LD	S+		Get value
	OUT	$88		Write to port 88
	SJMP	wend1		And proceed
out89	LD	S+		Get value
	OUT	$89		Write to port 89
	SJMP	wend1		And proceed
* Clean up stacked value & return to loop
wend2	LD	S+		Clean first value
wend1	LD	S+		Clean second value
	JMP	top
